/* global module: false */
'use strict';

module.exports = {
  root: true,
  parserOptions: {
    ecmaFeatures: {
      experimentalObjectRestSpread: true,
    },
    ecmaVersion: 2017,
    sourceType: 'module',
  },
  extends: [
    'eslint:recommended',
    'plugin:ember/recommended',
  ],
  env: {
    amd: true,
    browser: true,
    commonjs: true,
    es6: true,
    node: true,
    qunit: true,
    serviceworker: true,
    'shared-node-browser': true,
    worker: true,
  },
  rules: {
    'ember/alias-model-in-controller': "off",
    'ember/avoid-leaking-state-in-components': ["error", [
      "attributeBindings",
      "classNames",
      "classNameBindings",
      "localClassNames",
      "localClassNameBindings",
    ]],
    'ember/named-functions-in-promises': ["warn", {
      allowSimpleArrowFunction: true,
    }],
    'ember/order-in-components': ["warn", {
      order: [
        ["unknown", "query-params"],
        ["attribute", "relationship", "service", "property", "single-line-function", "multi-line-function"],
        ["actions", "lifecycle-hook", "method", "model"],
      ],
    }],
    'ember/order-in-routes': ["warn", {
      order: [
        ["service", 'inherited-property', 'property'],
        ["single-line-function", "multi-line-function"],
        ["lifecycle-hook", "model", "method"],
      ],
    }],
  },
};
